public class Trip { 
    String  description;
    Point[] points;
    int     time;
    int     id;

    byte[] pack() { 
        byte[] desc = Converter.packString(description);
        byte[] buf = new byte[desc.length + 8];
        Converter.packInt(buf, 4, time);
        System.arraycopy(desc, 0, buf, 8, desc.length);
        return buf;
    }

    void unpack(byte[] buf) {        
        time = Converter.unpackInt(buf, 4);
        description = Converter.unpackString(buf, 8, buf.length - 8);
    }

    Trip(int id, byte[] buf) { 
        this.id = id;
        unpack(buf);
    }

    int duration() { 
        return points.length > 0 ? points[points.length-1].time - time : 0;
    }

    Trip(String description, int time) { 
        this.description = description;
        this.time = time;
        points = new Point[0];
    }
}
