import javax.microedition.lcdui.*;

public class TripForm extends Form implements CommandListener
{ 
    TripMate  main;
    Trip      trip;
    int       index;
    TextField description;

    TripForm(int index, TripMate main) 
    {
        super("Trip");
        this.main = main;
        this.index = index;
        trip = (Trip)main.trips.elementAt(index);
        description = new TextField("Description", trip.description, 256, TextField.ANY);        
        append(description);
        int duration = trip.duration();
        if (duration != 0) { 
            append(new StringItem("Time", Converter.timeToString(duration)));
        }
        setCommandListener(this);
        addCommand(TripMate.BACK_CMD);
        addCommand(TripMate.UPDATE_CMD);
        addCommand(TripMate.NAVIGATE_CMD);
        addCommand(TripMate.BACKWARD_CMD);
        addCommand(TripMate.LIST_CMD);
        Display.getDisplay(main).setCurrent(this);
    }
           
    public void commandAction(Command c, Displayable d) 
    {    
        if (c == TripMate.UPDATE_CMD) {
            trip.description = description.getString();
            main.updateTrip(trip);
            main.mainMenu.set(main.trips.size() - index - 1, trip.description, null);
            Display.getDisplay(main).setCurrent(main.mainMenu);
        } else if (c == TripMate.NAVIGATE_CMD) {
            main.state.tripState = TripState.NAVIGATE_FORWARD;
            main.state.baseTime = main.state.startTime = (int)(System.currentTimeMillis() / 1000);
            main.state.tripNo = index;
            main.updateState();
            new NavigateCanvas(trip, main, this);
        } else if (c == TripMate.BACKWARD_CMD) { 
            main.state.tripState = TripState.NAVIGATE_BACKWARD;
            main.state.baseTime = main.state.startTime = (int)(System.currentTimeMillis() / 1000);
            main.state.tripNo = index;
            main.updateState();
            new NavigateCanvas(trip, main, this);
        } else if (c == TripMate.LIST_CMD) { 
            new PointList(trip, main, this);
        } else if (c == TripMate.BACK_CMD) { 
            Display.getDisplay(main).setCurrent(main.mainMenu);
        }
    }
}